Codeforces Round #741 (Div. 2) A-D

2023-10-09 15:38
文章标签 codeforces round div 741

本文主要是介绍Codeforces Round #741 (Div. 2) A-D,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

https://codeforces.com/contest/1562

A

给你两个数,问在两个数闭区间范围内的任意两个数之间取模的最大值

  • 显然如果想最大,那么相对较大的数要大,较小的那个数在较大的数一半的右侧,这里讨论一下 l l l的位置,如果他已经在右面了就直接输出差值或者模均可
#include <iostream>
#include <cstring>
#include <algorithm>
#include <queue>
#include <stack>
#include <vector>
#include <cmath>
#include <cstdio>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;
const int MAXN = 2e5 + 100;
const int INF = 0x3f3f3f3f;
int Data[MAXN];
int main(){#ifdef LOCALfreopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);#endifios::sync_with_stdio(false);int t, n, l, r;cin >> t;while(t--){cin >> l >> r;int k;k = (r / 2) + 1;if(l <= k){cout << r % k << '\n';}else{cout << r % l << '\n';}}return 0;
}

B

给你一个数,可以删掉若干位,问你最多删掉多少位能让剩下的数字变成一个非质数

  • 显然如果有某一位是非质数,那么就剩下他自己就好,如果所有位置全是质数,那么有这几种情况, 2 , 3 , 5 , 7 2,3,5,7 2,3,5,7,题目保证一定有解,那么这些数字任意两个组合起来都不是质数(类似 23 23 23这种情况属于无解的情况,不存在的)
  • 所以这种情况下只要看任意两个数组合起来是不是非质数即可
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int INF = 0x3f3f3f3f;
const int MAXN = 1e6 + 100;
const double eps = 1e-6;
int a[MAXN];
int vis[MAXN];
int p[MAXN];
int Prime(){int tot = 0;for(int i=2;i<=100;i++){if(!vis[i]) p[tot++] = i;for(int j=0;j<tot&&i*p[j]<=100;j++){vis[i*p[j]] = 1;if(i % p[j] == 0) break;}}return tot;
}
int main(){#ifdef LOCALfreopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);#endifios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t, k, n;int len = Prime();cin >> t;string s;while(t--){cin >> n >> s;bool f = false;for(int i=0;i<n;i++){int pos = lower_bound(p, p + len, s[i] - '0') - p;if(p[pos] != s[i] - '0'){f = true;cout << 1 << '\n';cout << s[i] - '0' << '\n';break;}}if(f) continue;for(int i=0;i<n;i++){int num = s[i] - '0';num *= 10;for(int j=i+1;j<n;j++){num += s[j] - '0';int pos = lower_bound(p, p + len, num) - p;if(p[pos] != num){cout << 2 << '\n';cout << num << '\n';f = true;break;}num -= s[j] - '0';}if(f) break;}}return 0;
}

C

给你一组 01 01 01串,设从 l l l r r r这段组成一个二进制数,让你找两段二进制数,满足前一个是后一个的 k k k倍, k k k是一个非负数,且满足 r − l + 1 ≥ ⌊ n 2 ⌋ r-l+1\geq \lfloor \frac{n}{2}\rfloor rl+12n

  • 0 0 0的位置,如果没有 0 0 0,那么只要随便找两个相等的数即可,如果有 0 0 0,如果位置在左面一半,那么找两个数从当前一直到末尾即可,否则就是从 1 1 1到当前位置,不细说了,很简单
#include <iostream>
#include <cstring>
#include <algorithm>
#include <queue>
#include <stack>
#include <vector>
#include <cmath>
#include <cstdio>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;
const int MAXN = 2e5 + 100;
const int INF = 0x3f3f3f3f;
int Data[MAXN];
int main(){#ifdef LOCALfreopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);#endifios::sync_with_stdio(false);int t, n;string s;cin >> t;while(t--){cin >> n >> s;int k = (n >> 1);bool f = false;for(int i=0;i<n;i++){if(s[i] == '0'){if(i >= k){cout << 1 << ' ' << i + 1 << ' ' << 1 << ' ' << i << '\n';f = true;break;}else{cout << i + 1 << ' ' << n << ' ' << i + 2 << ' ' << n << '\n';f = true;break;}}}if(!f){cout << 1 << ' ' << k << ' ' << 2 << ' ' << k + 1 << '\n';}}return 0;
}

D

给出了一个公式和一个字符串, + + +表示 1 1 1 − - 表示 − 1 -1 1,问在给定的一段区间内至少去掉多少个字符才能保持这段区间内的符号所对的公式值为 0 0 0

  • 我们先维护一个前缀和 s u m sum sum,如果这段区间对应的值已经是 0 0 0,那么就不需要修改了
  • 如果不是,考虑删除位置 i i i以后,整个序列的答案,删除位置 i i i以后,他前面的部分不变,但是后面的部分变成了原来的相反数,也就是现在序列变成了 s u m [ r ] − s u m [ i ] − ( s u m [ i − 1 ] − s u m [ l − 1 ] ) sum[r]-sum[i]-(sum[i-1]-sum[l-1]) sum[r]sum[i](sum[i1]sum[l1])也就是 s u m ] r ] + s u m [ l − 1 ] − s u m [ i ] − s u m [ i − 1 ] sum]r]+sum[l-1]-sum[i]-sum[i-1] sum]r]+sum[l1]sum[i]sum[i1]如果想让这个值为 0 0 0,那么应该有 s u m [ r ] + s u m [ l − 1 ] = s u m [ i ] + s u m [ i − 1 ] sum[r]+sum[l-1]=sum[i]+sum[i-1] sum[r]+sum[l1]=sum[i]+sum[i1]而我们已知的是 r , l r,l r,l,也就是说唯一不知道的值只是 i i i,而我们知道 s u m [ i ] sum[i] sum[i] s u m [ i − 1 ] sum[i-1] sum[i1]之间一定是差 1 1 1的,所以右侧一定是个奇数,那么考虑一下,如果 r − l + 1 r-l+1 rl+1是奇数,那么左面就变成了奇数,两侧有可能相等,那么如何寻找这个方案呢?
  • 其实我们可以预处理出来 s u m [ i ] + s u m [ i − 1 ] sum[i]+sum[i-1] sum[i]+sum[i1]所对应的所有 i i i值记录下来放到一个桶里面,然后对 s u m [ r ] + s u m [ l − 1 ] sum[r]+sum[l-1] sum[r]+sum[l1]这个标号的桶进行二分查找,找的一个大于 l l l的数,也就是第几个元素,即 i i i
  • 如果 i − l + 1 i-l+1 il+1是偶数,那么可以先把最左面的元素删去,让它变成刚才讨论的情况 1 1 1
  • 那么为什么 n n n为i奇数时,必然能够找到一个位置满足情况呢?设 f ( i ) f(i) f(i)表示去掉 i i i之后的值,那么有 f ( 1 ) = − ( s u m [ n ] − a [ 1 ] ) = a [ 1 ] − s u m [ n ] f(1)=-(sum[n]-a[1])=a[1]-sum[n] f(1)=(sum[n]a[1])=a[1]sum[n] f ( n ) = s u m ( n ) − a [ n ] f(n)=sum(n)-a[n] f(n)=sum(n)a[n]这其中能够影响到函数正负的是 s u m sum sum,所以 f ( 1 ) × f ( n ) ≤ 0 f(1)\times f(n)\leq 0 f(1)×f(n)0,因为函数连续,这说明在这中间一定存在一个数 i i i使得函数值为 0 0 0,这样就印证了刚才的唯一性结论
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
#include <unordered_map>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int INF = 0x3f3f3f3f;
const int MAXN = 1e6 + 100;
const double eps = 1e-6;
int a[MAXN];
int sum[MAXN];
int main(){#ifdef LOCALfreopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);#endifios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t, n, q, l, r;string s;cin >> t;while(t--){cin >> n >> q;cin >> s;int num = 1, op;unordered_map<int, vector<int> > mp;for(int i=1;i<=n;i++){if(s[i - 1] == '+') op = 1;else op = -1;sum[i] = op * num + sum[i - 1];num *= -1;mp[sum[i] + sum[i - 1]].push_back(i);}while(q--){cin >> l >> r;if(sum[r] - sum[l - 1] == 0) cout << 0 << '\n';else{if((l & 1) ^ (r & 1)){cout << 2 << '\n';cout << l++ << ' ';}else {cout << 1 << '\n';}auto &v = mp[sum[r] + sum[l - 1]];cout << *lower_bound(v.begin(), v.end(), l) << '\n';}}}return 0;
}

这篇关于Codeforces Round #741 (Div. 2) A-D的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/173846

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There